#!/usr/local/bin/python3

from collections import OrderedDict
import re

def readFasta_dict(InfileNameFN):
    Infile = open(InfileNameFN, "r")
    seqDictFN  = OrderedDict()
    for Line in Infile:
        Line = Line.rstrip("\n")
        if Line[0] == ">":
            Name            = Line
            seqDictFN[Name] = ""
        else:
            seqDictFN[Name] += Line
    Infile.close()
    return seqDictFN

def read_annotation(file_annotation):
    fs = open(file_annotation)
    lines_annotation = list(fs)
    fs.close()

    recs_annotation = []
    for line in lines_annotation:
        line = line.rstrip("\n")
        match = re.search("^ +([^ ]+) +([^\.]+)\.\.([^\.]+)$", line)
        gene = match.group(1)
        start = match.group(2)
        end = match.group(3)
        recs_annotation.append([gene,start,end])
    return recs_annotation

def slice_genes(gene, start, end):
    print(gene,start, end)
    out = open("020_" + gene + ".txt", "w")
    for name, seq in seqDict.items():
        out.write(name + "\n")
        out.write(seq[int(start)-1:int(end)] + "\n")
    out.close()


InfileName = "010infile_fasta.txt"
seqDict = readFasta_dict(InfileName)

recs_annotation = read_annotation("010annotation.txt")

for rec_annotation in recs_annotation:
    gene = rec_annotation[0]
    start = rec_annotation[1]
    end = rec_annotation[2]
    slice_genes(gene, start, end)
    
exit()


